--Procedimiento 3: p_Cons_Elect_Ciudad

--Dado un mes y un país concreto, consumo eléctrico de cada ciudad como suma de todos los contadores instalados.

--Parámetros de entrada
--	pMes: character
--	pPais: character
--Parámetros de salida
--	Tabla Rsp: TB_CONS_ELECT_CIUDAD

DROP TABLE TB_CONS_ELECT_CIUDAD;

CREATE TABLE TB_CONS_ELECT_CIUDAD (
 ciudad character(50),
 consumo real);


CREATE OR REPLACE FUNCTION p_Cons_Elect_Ciudad(pMes character(2), pPais character(50))
    RETURNS TABLE (ciudad character(50), consumo real) AS
$$
    DELETE FROM TB_CONS_ELECT_CIUDAD;
    INSERT INTO TB_CONS_ELECT_CIUDAD 
       SELECT cons."Ciudad", sum(log."ConsumoContador")
                                         FROM "Consumidores" cons,
                                              "Contadores" cont,
                                              "LogConexion" log
                                         WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $1
                                         AND log."NumeroSerieContador"     = cont."NumeroSerie" 
                                         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
                                         AND cons."Pais"                   = $2
                                         GROUP BY cons."Ciudad"
                                         ORDER BY 1;

    SELECT cons."Ciudad", sum(log."ConsumoContador")
                                         FROM "Consumidores" cons,
                                              "Contadores" cont,
                                              "LogConexion" log
                                         WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $1
                                         AND log."NumeroSerieContador"     = cont."NumeroSerie" 
                                         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
                                         AND cons."Pais"                   = $2
                                         GROUP BY cons."Ciudad"
                                         ORDER BY 1;
$$ LANGUAGE SQL;

select * from p_Cons_Elect_Ciudad('02','Espanya');



