--Procedimiento 1: p_Consumo_Electrico_Mensual

--El consumo eléctrico mensual de cada contador medido en KW/h.

DROP TABLE TB_CONSUMO_ELECTRICO_MENSUAL;

CREATE TABLE TB_CONSUMO_ELECTRICO_MENSUAL (
"Modelo" character(12),
"NumeroSerieContador" integer,
"FechaConexion" text,
"ConsumoContador" real);

-- Función ver usuarios por Nombre
CREATE OR REPLACE FUNCTION p_Consumo_Electrico_Mensual() RETURNS table (Modelo character(12), NumeroSerieContador integer,FechaConexion text, consumo real) AS
$$
    INSERT INTO TB_CONSUMO_ELECTRICO_MENSUAL
       SELECT cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2) mes,sum(log."ConsumoContador")
                                         FROM "Contadores" cont,
                                              "LogConexion" log
                                         WHERE cont."NumeroSerie" = log."NumeroSerieContador"
                                         GROUP BY cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2)
                                         order by 1,2,3;

    SELECT cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2) mes,sum(log."ConsumoContador")
                                         FROM "Contadores" cont,
                                              "LogConexion" log
                                         WHERE cont."NumeroSerie" = log."NumeroSerieContador"
                                         GROUP BY cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2)
                                         order by 1,2,3;
$$ LANGUAGE SQL;

select * from p_Consumo_Electrico_Mensual();

