--Procedimiento 9: p_Consumo_Medio

--Consumo medio de todos los consumidores para cada ciudad y mes.

--Parámetros de entrada
--	pCiudad: character
--	pMes: character
--Parámetros de salida
--	Rsp: character
--	Tabla Rsp: TB_CONSUMO_MEDIO

DROP TABLE TB_CONSUMO_MEDIO;

CREATE TABLE TB_CONSUMO_MEDIO
 (
 NIF character(12),
 Direccion character(50),
 mes character(2),
 ciudad character(50),
 ConsumoMedio real
 );

CREATE OR REPLACE FUNCTION p_Consumo_Medio(pCiudad character(50), pMes character(2))
    RETURNS TABLE (NIF character(12), 
                   Direccion character(50), 
                   mes character(2), 
                   ciudad character(50), 
                   ConsumoMedio real) AS
$$
    DELETE FROM TB_CONSUMO_MEDIO;
    INSERT INTO TB_CONSUMO_MEDIO
    SELECT cons."NIF", cons."Direccion", cons."Ciudad" ,
            substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) as Mes, log."ConsumoContador"
      FROM "LogConexion" log,
           "Contadores" cont,
           "Consumidores" cons
      WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $2
        AND log."NumeroSerieContador" = cont."NumeroSerie"
        AND cont."CodigoContratoAsociado" =  cons."CodigoContratoContador"
        AND cons."Ciudad" = $1;
        
    SELECT cons."NIF", cons."Direccion", cons."Ciudad" ,
            substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) as Mes, log."ConsumoContador"
      FROM "LogConexion" log,
           "Contadores" cont,
           "Consumidores" cons
      WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $2
        AND log."NumeroSerieContador" = cont."NumeroSerie"
        AND cont."CodigoContratoAsociado" =  cons."CodigoContratoContador"
        AND cons."Ciudad" = $1;
        
$$ LANGUAGE SQL;

select * from p_Consumo_Medio('Barcelona','2');

