--Procedimiento 5: p_List_Cont_Antig

--Listado de contadores que tengan un determinado numero de años de antigüedad.

--Parámetros de entrada
--	pAntiguedad: integer (Número de años de antigüedad)
--Parámetros de salida
--	Tabla Rsp: TB_LIST_CONT_ANTIG


DROP TABLE TB_LIST_CONT_ANTIG

CREATE TABLE TB_LIST_CONT_ANTIG (
 Modelo character(12), 
 NumeroSerie integer, 
 FechaInstalacion date
 )


CREATE OR REPLACE FUNCTION p_List_Cont_Antig(Antiguedad integer)
    RETURNS TABLE (Modelo character(12), NumeroSerie integer, FechaInstalacion date) AS
$$
    DELETE FROM TB_LIST_CONT_ANTIG;
    INSERT INTO TB_LIST_CONT_ANTIG
    SELECT cont."Modelo", cont."NumeroSerie", cont."FechaInstalacion"
                                         FROM "Contadores" cont
                                        WHERE extract(year from now()) - extract(year from cont."FechaInstalacion") = $1; 
                                       
    SELECT cont."Modelo", cont."NumeroSerie", cont."FechaInstalacion"
                                         FROM "Contadores" cont
                                        WHERE extract(year from now()) - extract(year from cont."FechaInstalacion") = $1; 
                        
$$ LANGUAGE SQL;

select * from p_List_Cont_Antig(2);


