--Procedimiento 2: p_List_Cont_Cons_Mensual

--Dada una ciudad y un mes cómo parámetros, el listado de todos los contadores donde el consumo mensual
-- ha superado el 80% del consumo medio de todos los contadores de la ciudad en ese mismo período de
--tiempo. Todo esto ordenado de forma ascendente por el tanto por ciento de consumo eléctrico consumido

--Parámetros de entrada
--	pCiudad: character
--	pMes: character
--Parámetros de salida
--	Rsp: character
--	Tabla Rsp: TB_LIST_CONT_CONS_MENSUAL
--Procedimiento asociado
--	Procedimiento asociado p_List_Cont_Cons_Mensual

DROP TABLE TB_LIST_CONT_CONS_MENSUAL;

CREATE TABLE TB_LIST_CONT_CONS_MENSUAL (
 

-- Función ver usuarios por Nombre
CREATE OR REPLACE FUNCTION p_List_Cont_Cons_Mensual() RETURNS table (Modelo character(12), NumeroSerieContador integer,FechaConexion text, consumo real) AS
$$
    DELETE FROM TB_CONSUMO_ELECTRICO_MENSUAL;
    INSERT INTO TB_CONSUMO_ELECTRICO_MENSUAL
       SELECT cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2) mes,sum(log."ConsumoContador")
                                         FROM "Contadores" cont,
                                              "LogConexion" log
                                         WHERE cont."NumeroSerie" = log."NumeroSerieContador"
                                         GROUP BY cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2)
                                         order by 1,2,3;

    SELECT cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2) mes,sum(log."ConsumoContador")
                                         FROM "Contadores" cont,
                                              "LogConexion" log
                                         WHERE cont."NumeroSerie" = log."NumeroSerieContador"
                                         GROUP BY cont."Modelo", cont."NumeroSerie",substr(to_char("FechaConexion",'yyyy-mm-dd'),6,2)
                                         order by 1,2,3;
$$ LANGUAGE SQL;

select * from p_Consumo_Electrico_Mensual();

