--Procedimiento 4: p_Porcentaje_Lecturas

--Dada una empresa de suministros y un mes concreto, 
--porcentaje de lecturas de contadores efectuadas de forma correcta. Se consideran 
--como tal las que la conexión se ha efectuado de manera correcta y se ha podido leer la lectura.

--Parámetros de entrada
--	pEmpresa: character
--	pMes: carácter
--Parámetros de salida
--	Tabla Rsp: TB_PORCENTAJE_LECTURAS

DROP TABLE TB_PORCENTAJE_LECTURAS;

CREATE TABLE TB_PORCENTAJE_LECTURAS (
 porcentaje numeric);


CREATE OR REPLACE FUNCTION p_Porcentaje_Lecturas(pEmpresa character(50), pMes character(2))
    RETURNS TABLE (porcentaje numeric) AS
$$
    DELETE FROM TB_PORCENTAJE_LECTURAS;
    INSERT INTO TB_PORCENTAJE_LECTURAS
    SELECT (count(1)*0.1)*100 AS PORCENTAJE 
                                         FROM "Empresas" emp,
                                              "Consumidores" cons,
                                              "Contadores" cont,
                                              "LogConexion" log
                                         WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $2
                                         AND log."ResultatLectura" = 'OK'
                                         AND log."NumeroSerieContador"     = cont."NumeroSerie" 
                                         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
                                         AND cons."CodigoEmpresaSubministradora" = emp."IdEmpresa"
                                         AND emp."Nombre" = $1;
    SELECT (count(1)*0.1)*100 AS PORCENTAJE 
                                         FROM "Empresas" emp,
                                              "Consumidores" cons,
                                              "Contadores" cont,
                                              "LogConexion" log
                                         WHERE substr(to_char(log."FechaConexion",'yyyy-mm-dd'),6,2) = $2
                                         AND log."ResultatLectura" = 'OK'
                                         AND log."NumeroSerieContador"     = cont."NumeroSerie" 
                                         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
                                         AND cons."CodigoEmpresaSubministradora" = emp."IdEmpresa"
                                         AND emp."Nombre" = $1;
    
$$ LANGUAGE SQL;

select * from p_Porcentaje_Lecturas('Sonic, S.L.','10');

