--Procedimiento 8: p_Top10_Contadores

--Top-10 de contadores que históricamente han tenido más consumo a cada una de les ciudades

--Parámetros de entrada
--	pCiudad: character
--Parámetros de salida
--	Rsp: character
--	Tabla Rsp: TB_TOP_CONTADORES

DROP TABLE TB_TOP_CONTADORES;

CREATE TABLE TB_TOP_CONTADORES (
 Modelo character(50),
 NumeroSerie integer,
 ConsumoContador real);

CREATE OR REPLACE FUNCTION p_Top10_Contadores(pCiudad character(50))
    RETURNS TABLE (Modelo character(50), NumeroSerie integer, ConsumoContador real) AS
$$
    DELETE FROM TB_TOP_CONTADORES;
    INSERT INTO TB_TOP_CONTADORES 
       SELECT cont."Modelo", cont."NumeroSerie", log."ConsumoContador"
         FROM "Consumidores" cons,
              "Contadores" cont,
              "LogConexion" log
         WHERE log."NumeroSerieContador" = cont."NumeroSerie"
         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
         AND cons."Ciudad" = 'Barcelona'
         ORDER BY log."ConsumoContador" 
         DESC LIMIT 10;

    SELECT cont."Modelo", cont."NumeroSerie", log."ConsumoContador"
         FROM "Consumidores" cons,
              "Contadores" cont,
              "LogConexion" log
         WHERE log."NumeroSerieContador" = cont."NumeroSerie"
         AND cont."CodigoContratoAsociado" = cons."CodigoContratoContador"
         AND cons."Ciudad" = 'Barcelona'
         ORDER BY log."ConsumoContador" 
         DESC LIMIT 10;
$$ LANGUAGE SQL;

select * from p_Top10_Contadores('Barcelona');

